package com.biganto.visual.roompark.domain.use_case

//import io.reactivex.Observable
import com.biganto.visual.roompark.domain.contract.AuthContract
import com.biganto.visual.roompark.domain.contract.DeviceUtilsContract
import com.biganto.visual.roompark.domain.contract.SubscriptionContract
import io.reactivex.rxkotlin.Observables
import javax.inject.Inject
//import io.reactivex.rxkotlin

/**
 * Created by Vladislav Bogdashkin on 01.11.2019.
 */

class SubscriptionUseCase @Inject constructor(
    private val subscription: SubscriptionContract,
    private val utils: DeviceUtilsContract,
    private val auth: AuthContract
){
    fun subscribeTopic(subId:Int,topic:String, topicId:String?=null) =
        Observables.zip(auth.currentUser(),utils.getDeviceId()){ u, t ->
            subscription.subscribeTopic(u,subId,t,topic = topic,topic_id = topicId)
        }

    fun unSubscribeTopic(subId:Int,topic:String, topicId:String?=null) =
        Observables.zip(auth.currentUser(),utils.getDeviceId()){ u, t ->
            subscription.subscribeTopic(u,subId,t,topic = topic,topic_id = topicId)
        }

}